<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item :label="systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="手机号" prop="mobile">
        <el-input
            v-model="queryParams.mobile"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <span style="color: red">提示：本页面数据不实时更新，每天凌晨会更新昨日发言</span>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="anchorImCountDayList" @selection-change="handleSelectionChange">
      <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      <el-table-column label="发言量" align="center" prop="imCount" />
      <el-table-column label="手机号" align="center" prop="mobile"/>
      <el-table-column label="昵称" align="center" prop="nickname"/>
      <el-table-column label="头像" align="center" prop="avatar">
        <template v-slot="scope">
          <image-avatar :src="scope.row.avatar"/>
        </template>
      </el-table-column>
      <el-table-column label="IM状态" align="center" prop="im" >
        <template v-slot="scope">
          <el-tag v-if="scope.row.enableIm && scope.row.imSpeck" :disable-transitions="true" type="primary">正常</el-tag>
          <el-tag v-if="scope.row.enableIm && !scope.row.imSpeck" :disable-transitions="true" type="warning">禁言</el-tag>
          <el-tag v-if="!scope.row.enableIm && scope.row.imSpeck"  :disable-transitions="true" type="danger">封禁</el-tag>
          <el-tag v-if="!scope.row.enableIm && !scope.row.imSpeck"  :disable-transitions="true" type="danger">封禁+禁言</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <cai-dict-tag :options="userStatusList" :value="scope.row.status" />
        </template>
      </el-table-column>
      <el-table-column label="数据更新时间" align="center" prop="refreshTime" width="180" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width"  width="180" fixed="right">
        <template slot-scope="scope">
          <el-button size="mini" type="text" v-hasPermi="['cai:user:im']" v-if="scope.row.enableIm" @click="handleLockIm(scope.row)" icon="el-icon-lock"><span style="color: red">封禁IM</span></el-button>
          <el-button size="mini" type="text" v-hasPermi="['cai:user:im']" v-if="!scope.row.enableIm" @click="handleUnlockIm(scope.row)" icon="el-icon-unlock"><span style="color: blue">解封IM</span></el-button>
          <el-button size="mini" type="text" v-hasPermi="['cai:user:im']" v-if="scope.row.imSpeck" @click="handleNoSpeckIm(scope.row)" icon="el-icon-lock"><span style="color: red">禁言</span></el-button>
          <el-button size="mini" type="text" v-hasPermi="['cai:user:im']" v-if="!scope.row.imSpeck" @click="handleEnSpeckIm(scope.row)" icon="el-icon-unlock"><span style="color: blue">解封禁言</span></el-button>
          <el-button size="mini" type="text" v-hasPermi="['cai:user:lock']" @click="handleUserForbid(scope.row)" icon="el-icon-lock">封禁</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <user-forbid-dialog v-if="userForbidVisible" ref="userForbid" @refreshDataList="getList" />
  </div>
</template>

<script>
import {listAnchorImCountDayUserTotal} from "@/api/cai/anchorImCountDay";
import {enSpeckIm, lockIm, noSpeckIm, unLockIm} from "@/api/cai/user";
import UserForbidDialog from "@/views/cai/user/user-forbid-dialog.vue";
import {userStatusList} from "@/constant/statusMap";

export default {
  name: "ImTotalCountIndex",
  components: {UserForbidDialog},
  data() {
    return {
      userStatusList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      userForbidVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 每日发言统计表格数据
      anchorImCountDayList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        mobile: undefined,
        usercode: undefined,
        countDate: new Date(),
      },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询每日发言统计列表 */
    getList() {
      this.loading = true;
      listAnchorImCountDayUserTotal(this.queryParams).then(response => {
        this.anchorImCountDayList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length!==1
      this.multiple = !selection.length
    },
    handleLockIm(row){
      this.$modal.confirm('是否确认封禁用户"' + row.nickname + '"的IM？').then(() => {
        this.loading = true;
        return lockIm(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleUnlockIm(row){
      this.$modal.confirm('是否确认解封用户"' + row.nickname + '"的IM？').then(() => {
        this.loading = true;
        return unLockIm(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleNoSpeckIm(row){
      this.$modal.confirm('是否确认封禁用户"' + row.nickname + '"的IM聊天功能？').then(() => {
        this.loading = true;
        return noSpeckIm(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleEnSpeckIm(row){
      this.$modal.confirm('是否确认解封用户"' + row.nickname + '"的IM聊天功能？').then(() => {
        this.loading = true;
        return enSpeckIm(row.id);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleUserForbid(row){
      this.userForbidVisible = true
      this.$nextTick(() => {
        this.$refs.userForbid.init(row.id)
      })
    },
  }
};
</script>
